
	set    RAMSTACK%,0xE000
	set    PROMOUT%,0x40
	set    TEXTSIZE%,0x10000

/* ************* */ 
/* icb command */
/* ************* */
	set	IMEMCMD%, 0x81
	set	IWJCMD%, 0x0c
	set	IILLEG%, 0x88

	set	ram_start%,0x400000
	set	ram_size%,0x010000	/* 64K */
	set prom_ram%,0x410000
	set	stack%,0x410000

	set	ledoff%,3
	set	redlit%,2
	set	greenlit%,1
	set	yellowlit%,0

	set	ICB_SR%,0x800000		/* ICB status register (R)  */
	set	ICB_IR%,0x800002		/* ICB inturrpt register (RW) */

	set	DTB_CR%,0x800004		/* DTB control register (W)  */
	set	DTB_SR%,0x800004		/* DTB status register (R)  */
	set	DTB_IDR%,0x800006	/* DTB ID register (W)  */

	set	DBC_CR%,0x600000		/* DBC control register (W)  */
	set	DBC_SR%,0x600000		/* DBC status register (R)  */

	set	DDC_DMAS%,0x600040	/* DDC dma start addr reg(R/W)  */
	set	DDA_DMAS%,0x600042	/* DDC ALT dma start addr reg(R/W)  */
	set	CHN_DMAS%,0x600044	/* CHAIN dma start addr reg (R/W)  */
	set	DTB_DMAS%,0x600046	/* DTB dma start addr register (R/W)  */
	set	TP_DMAS%,0x600048	/* TAPE dma start addr register (R/W)  */

	set	DDC_DMAE%,0x600060	/* DDC dma end addr register (R/W)  */
	set	DDA_DMAE%,0x600062	/* DDC ALT dma end addr reg(R/W)  */
	set	CHN_DMAE%,0x600064	/* CHAIN dma end addr reg (R/W)  */
	set	DTB_DMAE%,0x600066	/* DTB dma end addr register (R/W)  */
	set	TP_DMAE%,0x600068	/* TAPE dma end addr register (R/W)  */
	set BNK_SEL%,0x6000e0	/* DMA memory bank select (W)  */

	set	DDC_CR%,0x8000b0		/* DDC control register (W)  */
	set	DDC_SR%,0x8000b0		/* DDC status register (R)  */

	set	DDC_TR%,0x800081		/* DDC timing register (R/W)  */

	set	DDC_IDR%,0x8000a1	/* DDC ID register (R/W)  */

	set	DDC_SCR%,0x800032	/* DISK sector register (R/W)  */
	set	TP_CR%,0x800038		/* TAPE control register (W)  */
	set	TP_SR%,0x800038		/* TAPE status register (R)  */
	set	DTC_CRL%,0x800001	/* DTC control register (W)  */
	set	SWITCHES%,0x800031	/* dip switches (R)  */

/* 6850 serial chip  */
	set	ACIA_CNTRL%,0x8000c1	/* 6850 control register  */
	set	ACIA_STAT%,0x8000c1	/* 6850 status register  */
	set	ACIA_DATA%,0x8000c3	/* 6850 data register  */


/* 6840 timer chip   */
	set	TM_C13%,0x8000e1		/* control reg 1 & 3  */
	set	TM_C2%,0x8000e3		/* control reg 2  */
	set	TM_S2%,0x8000e3		/* status register 2  */
	set	TM_MSB1%,0x8000e5	/* count reg 1 (msb)  */
	set	TM_LSB1%,0x8000e7	/* count reg 1 (lsb)  */
	set	TM_MSB2%,0x8000e9	/* count reg 2 (msb)  */
	set	TM_LSB2%,0x8000eb	/* count reg 2 (lsb)  */
	set	TM_MSB3%,0x8000ed	/* count reg 3 (msb)  */
	set	TM_LSB3%,0x8000ef	/* count reg 3 (lsb)  */

/* DISK Bus Register WRITE  */
/*                    x		 for drive num  */
/*                    |                    */
	set	DK_WCY%,0xc00000		/* DISK Bus write cylinder  */
	set	DK_WHD%,0xc00002		/* DISK Bus write head  */
	set	DK_WCTL%,0xc00004	/* DISK Bus write control  */
	set	DK_WSI%,0xc00006		/* DISK Bus enable seek,end interrupt  */

	set	DK_RUS%,0xc00000		/* DISK read unit status  */
	set	DK_RSCS%,0xc00002	/* DISK read sector status  */
	set	DK_RRWC%,0xc00004	/* DISK read write/read check  */
	set	DK_RACS%,0xc00006	/* DISK read access status  */

