	#.page
#-----------------------------------------------------------------------------
#
#	M I S C
#
#-----------------------------------------------------------------------------

# put into a stand alone m68 library

	global	spl0,spl1,spl2,spl3,spl4,spl5,spl6,spl7
	global	splhi,splx
	global	bcopy

	text
	#.page
#-----------------------------------------------------------------------------
#
#	S Y S T E M    P R I V I L E G E    L E V E L S
#
#-----------------------------------------------------------------------------

spl0:
	mov.w	%sr,%d0		# previous level
	and.w	&0xf8ff,%sr	# allow all level interrupt
	rts

spl1:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0100,%d1	# allow 2-7 level interrupt
	mov.w    %d1,%sr
	rts

spl2:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0200,%d1	# allow 3-7 level interrupt
	mov.w    %d1,%sr
	rts

spl3:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0300,%d1	# allow 4-7 level interrupt
	mov.w    %d1,%sr
	rts

spl4:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0400,%d1	# allow 5-7 level interrupt
	mov.w    %d1,%sr
	rts

splhi:
spl5:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0500,%d1	# allow 6-7 level interrupt
	mov.w    %d1,%sr
	rts

spl6:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0600,%d1	# allow 7 level interrupt
	mov.w    %d1,%sr
	rts

spl7:
	mov.w	%sr,%d0		# previous level
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	&0x0700,%d1	# allow no interrupt
	mov.w    %d1,%sr
	rts

splx:
	mov.w	6(%sp),%d0
	and.w	&0x0700,%d0
	mov.w	%sr,%d1
	and.w	&0xf8ff,%d1
	or.w	%d1,%d0
	mov.w	%d0,%sr
	rts

#------------------------------------------------------------------
#
#	B C O P Y
#
#	bcopy(source, destination, count)
#
#------------------------------------------------------------------
	
bcopy:
	mov.l	4(%sp),%a0		# source
	mov.l	8(%sp),%a1		# destination
	mov.l	12(%sp),%d0
	beq.b	bc090%			# zero count
	mov.l	%a0,%d1
	or.l	8(%sp),%d1
	and.l	&1,%d1			# word aligned
	beq.b	bc030%

bc005%:
	sub.l	&1,%d0

bc010%:
	mov.b	(%a0)+,(%a1)+
	dbvs	%d0,bc010%
bc090%:
	rts
bc030%:
	mov.l	%d0,%d1
	lsr.l	&5,%d1
	beq.b	bc005%			# less than 32 bytes left
	sub.l	&1,%d1			# don't do last 32 bytes in a page
	beq.b	bc005%
bc050%:					# do move multiple for 3x
	movm.l	&0x3f3c,-(%sp)		# save registers
	mov.l	&32,%d2
	mov.l	%a1,%d3			# d3 tracks a1
	sub.l	&1,%d1			# adjust for -1 termination
bc060%:
	movm.l	(%a0)+,&0x3cf0
	movm.l	&0x3cf0,(%a1)
	add.l	%d2,%d3
	mov.l	%d3,%a1
	dbvs	%d1,bc060%
	movm.l	(%sp)+,&0x3cfc		# restore registers
	mov.l	%d0,%d1
	lsr.l	&5,%d1
	sub.l	&1,%d1			# last 32 bytes of a page
	lsl.l	&5,%d1
	sub.l	%d1,%d0
	bne.b	bc005%			# some less than 32 left
	rts	


	#.end
